// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include <math.h>
#include "Stage.h"
#include "movie.h"
#include "MainFrm.h"
#include "indevdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ACTIVATEAPP()
	ON_WM_PALETTECHANGED()
	ON_WM_MOVE()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_EDIT_INSERTSHAPE, OnEditInsertShape)
	ON_WM_SETFOCUS()
	ON_UPDATE_COMMAND_UI(ID_EDIT_CONTROL, OnUpdateEditControl)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SELECTION, OnUpdateViewSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETESHAPE, OnUpdateEditDeleteshape)
	ON_COMMAND(ID_EDIT_DELETESHAPE, OnEditDeleteshape)
	ON_COMMAND(ID_EDIT_BKGNDIMG, OnEditBkgndImg)
	ON_COMMAND(ID_EDIT_INSWORLD, OnEditInsworld)
	ON_COMMAND(ID_EDIT_TREE, OnEditTree)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLONE, OnUpdateEditClone)
	ON_COMMAND(ID_EDIT_CLONE, OnEditClone)
	ON_COMMAND(ID_EDIT_INPUTDEV, OnEditInputdev)
	ON_COMMAND(ID_VIEW_SELECTION, OnViewSelection)
	ON_COMMAND(ID_EDIT_CONTROL, OnEditControl)
	ON_COMMAND(ID_EDIT_RECORD, OnEditRecord)
	ON_UPDATE_COMMAND_UI(ID_EDIT_STOP, OnUpdateEditStop)
	ON_COMMAND(ID_EDIT_STOP, OnEditStop)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PLAY, OnUpdateEditPlay)
	ON_COMMAND(ID_EDIT_PLAY, OnEditPlay)
	ON_UPDATE_COMMAND_UI(ID_EDIT_RECORD, OnUpdateEditRecord)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SAVE_AVI, OnUpdateEditSaveAvi)
	ON_COMMAND(ID_EDIT_SAVE_AVI, OnEditSaveAvi)
	ON_COMMAND(ID_EDIT_RECANIM, OnEditRecanim)
	ON_COMMAND(ID_EDIT_PLAYANIM, OnEditPlayanim)
	ON_COMMAND(ID_EDIT_ADDANIMKEY, OnEditAddanimkey)
	ON_UPDATE_COMMAND_UI(ID_EDIT_RECANIM, OnUpdateEditRecanim)
	ON_UPDATE_COMMAND_UI(ID_EDIT_ADDANIMKEY, OnUpdateEditAddanimkey)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PLAYANIM, OnUpdateEditPlayanim)
	ON_COMMAND(ID_EDIT_PLAYANIMCONT, OnEditPlayanimcont)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PLAYANIMCONT, OnUpdateEditPlayanimcont)
	ON_COMMAND(ID_EDIT_ANIMDEMO, OnEditAnimdemo)
	ON_COMMAND(ID_EDITSTOPANIM, OnEditstopanim)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pScene = NULL;
	m_pCurShape = FALSE;
	m_pController = NULL;
	m_iObjCtrlDev = 0;
	m_iControlObj = 0;
	m_iControlType = 0;
	m_pSelBox = NULL;
	m_bPlayAnimation = FALSE;
	m_bLoopAnim = FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// Create the 3D window
	if (!m_wnd3d.Create(this, IDC_3DWND)) {
		return -1;
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	NewScene();
	ASSERT(m_pScene);

	// Create the controller object
	if (m_iControlType == 0) {
		m_pController = new C3dPosCtlr;
	} else {
		m_pController = new C3dFlyCtlr;
	}
	m_pController->Create(&m_wnd3d,
						  OnGetCtrlFrame,
					      this);

	// restore the controller settings
	m_pController->SelectDevice(m_iObjCtrlDev);

	// enable mouse selection of objects
	m_wnd3d.EnableMouseSelection(OnSelChange, this);

	// Create the movie object
	m_Movie.Create(&m_wnd3d);
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// Restore any saved settings
	RestoreSettings();

	// Restore the window size and position
	cs.x = m_rcWnd.left;
	cs.y = m_rcWnd.top;
	cs.cx = m_rcWnd.Width();
	cs.cy = m_rcWnd.Height();

	return CFrameWnd::PreCreateWindow(cs);
}

BOOL CMainFrame::NewScene()
{
	HideSelection();

	// Delete any scene we might have
	if (m_pScene) {
		m_wnd3d.SetScene(NULL);
		delete m_pScene;
		m_pScene = NULL;
	}
	MakeCurrent(NULL);

	// Create an initial scene
	m_pScene = new C3dScene;
	if (!m_pScene->Create()) return FALSE;

	// Set up the lighting
    C3dDirLight dl;
    dl.Create(0.8, 0.8, 0.8);
    m_pScene->AddChild(&dl);
    dl.SetPosition(-2, 2, -5);
    dl.SetDirection(1, -1, 1);
    m_pScene->SetAmbientLight(0.4, 0.4, 0.4);

	// reset the camera position and direction
    m_pScene->SetCameraPosition(C3dVector(0, 0, -10));
    m_pScene->SetCameraDirection(C3dVector(0, 0, 1), C3dVector(0, 1, 0));


	m_wnd3d.SetScene(m_pScene);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();

	// Save the current settings
	SaveSettings();
	
	// remove any selection box
	HideSelection();

	// destroy the controller
	if (m_pController) {
		delete m_pController;
		m_pController = NULL;
	}

	// Delete any scene we might have
	m_wnd3d.SetScene(NULL);
	if (m_pScene) {
		delete m_pScene;
		m_pScene = NULL;
	}
	MakeCurrent(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// window layout handler

void CMainFrame::RecalcLayout(BOOL bNotify) 
{
    // Rearrange the control bars and fit the 3D window in the middle
	// Let the frame rearrange the control bars
	CFrameWnd::RecalcLayout(bNotify);

	// Find the space that's left over
	CRect rc;
	RepositionBars(0,
				   0xFFFF,
				   IDC_3DWND,
				   CWnd::reposQuery,
				   &rc);
	if (IsWindow(m_wnd3d.GetSafeHwnd())) {
		m_wnd3d.MoveWindow(&rc, FALSE);
	}
}


///////////////////////////////////////////////////////////////
// Windows messages we need to handle

void CMainFrame::OnActivateApp(BOOL bActive, HTASK hTask) 
{
	CFrameWnd::OnActivateApp(bActive, hTask);
	
	// Tell the 3D window about the new state
	m_wnd3d.SendMessage(WM_ACTIVATEAPP,
						(WPARAM)bActive,
						(LPARAM)hTask);
}

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	// Let the 3D window know
	m_wnd3d.SendMessage(WM_PALETTECHANGED,
					   pFocusWnd ? (WPARAM)pFocusWnd->GetSafeHwnd() : 0);
}

void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	
	// Let the 3D window know the frame has moved
	m_wnd3d.SendMessage(WM_MOVE, 0, MAKELPARAM(0, 0));
}

///////////////////////////////////////////////////////////////
// Adding new objects

void CMainFrame::OnFileNew() 
{
	NewScene();
}

BOOL CMainFrame::OpenFile(const char* pszPath)
{
	// Create a new scene
	NewScene();
	ASSERT(m_pScene);

	// Try for a shape file
	C3dShape* pShape = new C3dShape;
	const char* pszFile = pShape->Load(pszPath);
	if (!pszFile) {
		delete pShape;
		return FALSE;
	}


	// Attach the new shape to the scene
	m_pScene->AddChild(pShape);

	// Add it to the shape list
	m_pScene->m_ShapeList.Append(pShape);

	// Make it the current shape
	MakeCurrent(pShape);

	// Add the name to the recent file list
	AfxGetApp()->AddToRecentFileList(pszFile);
	Status("Opened: %s", pszFile);
	return TRUE;
}

void CMainFrame::OnFileOpen() 
{
	OpenFile(NULL);
}

void CMainFrame::OnEditInsertShape() 
{
	CShapeDlg dlg("Insert Shape", this);

	if (dlg.DoModal() != IDOK) return;

	// Add the new shape
	if (dlg.m_pShape) {
		ASSERT(m_pScene);
		m_pScene->AddChild(dlg.m_pShape);
		m_pScene->m_ShapeList.Append(dlg.m_pShape);
		MakeCurrent(dlg.m_pShape);
	}
}

///////////////////////////////////////////////////////////////
// Format a string for the status bar

void CMainFrame::Status(const char* pszFormat, ...)
{
	char buf[256];
	va_list arglist;
	va_start(arglist, pszFormat);
    vsprintf(buf, pszFormat, arglist);
	va_end(arglist);
	m_wndStatusBar.SetWindowText(buf);
	m_wndStatusBar.UpdateWindow();
}

//////////////////////////////////////////////////////////////
// Control device selection

void CMainFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CFrameWnd::OnSetFocus(pOldWnd);
	
	// Give the focus to the 3D window so it can process
	// keystrokes for the key input device
	m_wnd3d.SetFocus();
}

// callback from the dialog to get a frame to control
// static
C3dFrame* CMainFrame::OnGetCtrlFrame(void* pArg)
{
	CMainFrame* pThis = (CMainFrame*) pArg;
	ASSERT(pThis);
	ASSERT(pThis->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	if (pThis->m_iControlObj == 1) {
		return pThis->m_wnd3d.GetCamera();
	}
	return pThis->m_pCurShape;
}

void CMainFrame::OnEditControl() 
{
	CInpDevDlg dlg;
	dlg.m_iObject = m_iControlObj;
	dlg.m_iType = m_iControlType;
	dlg.m_iDevice = m_iObjCtrlDev;
	if (dlg.DoModal() != IDOK) return;
	m_iControlObj = dlg.m_iObject;

	// set up the controller type
	if (dlg.m_iType != m_iControlType) {

		if (m_pController) delete m_pController;

		// create a new controller
		m_iControlType = dlg.m_iType;
		if (m_iControlType == 0) {
			m_pController = new C3dPosCtlr;
		} else {
			m_pController = new C3dFlyCtlr;
		}
		m_pController->Create(&m_wnd3d,
							  OnGetCtrlFrame,
							  this);
	}

	ASSERT(m_pController);
	m_pController->SelectDevice(dlg.m_iDevice);
 	m_iObjCtrlDev = m_pController->GetCurDevice();
	Status("Control is now via: %s", 
		   m_pController->GetDeviceName(m_iObjCtrlDev));
}

void CMainFrame::OnUpdateEditControl(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pController ? TRUE : FALSE);
}

void CMainFrame::OnEditInputdev() 
{
	ASSERT(m_pController);
	C3dInputDevice* pDev = m_pController->GetInputDevice();
	ASSERT(pDev);
	pDev->ShowConfigDlg();
}

//////////////////////////////////////////////////////////////////
// Save and Restore Settings

void CMainFrame::SaveSettings()
{
	CWinApp* pa = AfxGetApp();
	pa->WriteProfileInt("Settings","ControlDevice", m_iObjCtrlDev);
	CRect rc;
	GetWindowRect(&rc);
	pa->WriteProfileInt("Settings\\Window","Top", rc.top);
	pa->WriteProfileInt("Settings\\Window","Left", rc.left);
	pa->WriteProfileInt("Settings\\Window","Width", rc.Width());
	pa->WriteProfileInt("Settings\\Window","Height", rc.Height());
	pa->WriteProfileInt("Settings\\Options","ViewSel", m_bViewSelection);
}

void CMainFrame::RestoreSettings()
{
	CWinApp* pa = AfxGetApp();
	m_iObjCtrlDev = pa->GetProfileInt("Settings","ControlDevice", 0);
	m_rcWnd.top = pa->GetProfileInt("Settings\\Window","Top", 50);
	m_rcWnd.left = pa->GetProfileInt("Settings\\Window","Left", 50);
	m_rcWnd.right = m_rcWnd.left + pa->GetProfileInt("Settings\\Window","Width", 300); 
	m_rcWnd.bottom = m_rcWnd.top + pa->GetProfileInt("Settings\\Window","Height", 350);
	m_bViewSelection = (BOOL) pa->GetProfileInt("Settings\\Options","ViewSel", 1);
}

//////////////////////////////////////////////////////////////////////////
// object selection

// callback notification function
// called by m_wnd3d when the object selection changes
// static
void CMainFrame::OnSelChange(C3dShape* pShape, CPoint pt, void* pArg)
{
	CMainFrame* pThis = (CMainFrame*) pArg;
	ASSERT(pThis);
	ASSERT(pThis->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	pThis->MakeCurrent(pShape);
}

void CMainFrame::MakeCurrent(C3dShape* pShape)
{
	// Destroy any existing animation data
	m_Anim.Attach(NULL);
	m_Anim.DeleteAll();

	if (pShape == m_pCurShape) {
		return;
	}
	HideSelection();
	m_pCurShape = pShape;
	ShowSelection();
	if (m_pCurShape != NULL) {
		Status("Selected: %s, %d faces",
			   m_pCurShape->GetName(),
			   m_pCurShape->GetFaceCount());
	} else {
		Status("No selection");
	}
}

void CMainFrame::ShowSelection()
{
	// Remove any existing selection
	HideSelection();

	if (!m_bViewSelection) {
		return;	// View Selection is disabled by the user
	}

	if (!m_pCurShape) {
		return; // Nothing selected
	}


	// get the bounding box of the shape
	double x1, x2, y1, y2, z1, z2;
	BOOL b = m_pCurShape->GetBox(x1, y1, z1, x2, y2, z2);
	ASSERT(b);

	// create a new selection box around the shape
	m_pSelBox = new C3dShape;

	double r = 0.03;
	double rc = r * 2;
	C3dShape r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12, rd, ru, cd, cu;
	r1.CreateRod(x1, y1, z1, x2, y1, z1, r);
	m_pSelBox->AddChild(&r1);
	r2.CreateRod(x1, y1, z1, x1, y2, z1, r);
	m_pSelBox->AddChild(&r2);
	r3.CreateRod(x1, y1, z1, x1, y1, z2, r);
	m_pSelBox->AddChild(&r3);
	r4.CreateRod(x1, y2, z1, x2, y2, z1, r);
	m_pSelBox->AddChild(&r4);
	r5.CreateRod(x2, y1, z1, x2, y2, z1, r);
	m_pSelBox->AddChild(&r5);
	r6.CreateRod(x1, y2, z1, x1, y2, z2, r);
	m_pSelBox->AddChild(&r6);
	r7.CreateRod(x2, y2, z1, x2, y2, z2, r);
	m_pSelBox->AddChild(&r7);
	r8.CreateRod(x2, y1, z1, x2, y1, z2, r);
	m_pSelBox->AddChild(&r8);
	r9.CreateRod(x1, y1, z2, x1, y2, z2, r);
	m_pSelBox->AddChild(&r9);
	r10.CreateRod(x1, y1, z2, x2, y1, z2, r);
	m_pSelBox->AddChild(&r10);
	r11.CreateRod(x2, y1, z2, x2, y2, z2, r);
	m_pSelBox->AddChild(&r11);
	r12.CreateRod(x1, y2, z2, x2, y2, z2, r);
	m_pSelBox->AddChild(&r12);

	rd.CreateRod(0, 0, 0, 0, 0, z2 + 2 * r, r);
	m_pSelBox->AddChild(&rd);
	cd.CreateCone(0, 0, z2 + 2 * r, rc, TRUE, 0, 0, z2 + 6 * r, 0, FALSE);
	m_pSelBox->AddChild(&cd);

	ru.CreateRod(0, 0, 0, 0, y2 + r, 0, r);
	m_pSelBox->AddChild(&ru);
 	cu.CreateCone(0, y2 + r, 0, rc, TRUE, 0, y2 + 3 * r, 0, 0, FALSE);
	m_pSelBox->AddChild(&cu);

	// Set the position and orientation of the box to
	// match the shape
	C3dStage* pStage = m_wnd3d.GetStage();

	double x, y, z, xd, yd, zd, xu, yu, zu;
	m_pCurShape->GetPosition(x, y, z, pStage);
	m_pCurShape->GetDirection(xd, yd, zd, xu, yu, zu, pStage);
	m_pSelBox->SetPosition(x, y, z, pStage);
	m_pSelBox->SetDirection(xd, yd, zd, xu, yu, zu, pStage);

	// Attach the selection box to the current shape
	// so it will move with it
	m_pCurShape->AddChild(m_pSelBox);
}

void CMainFrame::HideSelection()
{
	if (!m_pSelBox) {
		return; // No current selection
	}
	ASSERT(m_pCurShape);
	m_pCurShape->RemoveChild(m_pSelBox);
	delete m_pSelBox;
	m_pSelBox = NULL;
}

void CMainFrame::OnUpdateViewSelection(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bViewSelection);	
}

void CMainFrame::OnViewSelection() 
{
	m_bViewSelection = !m_bViewSelection;
	ShowSelection();
}

void CMainFrame::OnUpdateEditDeleteshape(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnEditDeleteshape() 
{
	ASSERT(m_pScene);
	ASSERT(m_pCurShape);
	C3dShape* pShape = m_pCurShape;
	MakeCurrent(NULL);
	m_pScene->RemoveChild(pShape);
	m_pScene->m_ShapeList.Delete(pShape);
}

// Install a background image
void CMainFrame::OnEditBkgndImg() 
{
	C3dImage* pImg = new C3dImage;
	if (!pImg->Load()) {
		delete pImg;
		return;
	}

	ASSERT(m_pScene);
	m_pScene->m_ImgList.Append(pImg);
	m_pScene->SetBackground(pImg);
}

void CMainFrame::OnEditInsworld() 
{
	// Create a sphere for the planet
	C3dShape* pPlanet = new C3dShape;
	pPlanet->CreateSphere(2);

	// Load the texture map of the world
	C3dTexture* pTex1 = new C3dTexture;
	pTex1->Load(IDB_WORLD);
	m_pScene->m_ImgList.Append(pTex1);

	// Attach the texture to the shape
	pPlanet->SetTexture(pTex1);

	// Create a spherical wrap
	C3dWrap wrap;
    wrap.Create(D3DRMWRAP_SPHERE,
				NULL,
				0, 0, 0, // origin
				0, 0, 1, // direction
				0, 1, 0, // up
				0, 0,	 // texture origin
				1, 1);	 // texture scale

	// apply the wrap to the shapes
	wrap.Apply(pPlanet);

	pPlanet->SetDirection(0.5, 0.8, 0);

	pPlanet->SetName("World");
	m_pScene->AddChild(pPlanet);
	m_pScene->m_ShapeList.Append(pPlanet);
	MakeCurrent(pPlanet);
}


void CMainFrame::OnEditTree() 
{
	// load the texture maps
	C3dTexture* pTex1 = new C3dTexture;
	pTex1->Load(IDB_LEAVES);
	m_pScene->m_ImgList.Append(pTex1);
	C3dTexture* pTex2 = new C3dTexture;
	pTex2->Load(IDB_BARK);
	m_pScene->m_ImgList.Append(pTex2);

	// Create a cylindrical wrap
	C3dWrap wrap;
	wrap.Create(D3DRMWRAP_CYLINDER,
				NULL,
				0, 0, 0, // origin
				0, 0, 1, // direction
				0, 1, 0, // up
				0, 0,	 // texture origin
				1, 1);	 // texture scale


	// Create the tree and its trunk
	double h = (rand() % 100) / 50.0 + 1.0;
	double x = ((rand() % 100) - 50) / 10.0;
	double z = ((rand() % 100) - 50) / 10.0;
	double y = -2;

	C3dShape* pTree = new C3dShape;
	pTree->CreateCone(x, y+h/4, z, h/4, TRUE,
					  x, y+h, z, 0, FALSE);
	m_pScene->m_ShapeList.Append(pTree);
	C3dShape* pTrunk = new C3dShape;
	pTrunk->CreateRod(x, y, z,
					  x, y+h/4, z,
					  h/20);
	m_pScene->m_ShapeList.Append(pTrunk);
	pTree->AddChild(pTrunk);

	// apply the textures
	pTree->SetTexture(pTex1);
	wrap.Apply(pTree);

	pTrunk->SetTexture(pTex2);
	wrap.Apply(pTrunk);

	pTree->SetName("Tree");
	m_pScene->AddChild(pTree);

	MakeCurrent(pTree);
}

//////////////////////////////////////////////////////////////////////////////////////
// Cloning a shape

void CMainFrame::OnUpdateEditClone(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnEditClone() 
{
	ASSERT(m_pCurShape);
	C3dShape* pClone = m_pCurShape->Clone();
	m_pScene->m_ShapeList.Append(pClone);
	m_pScene->AddChild(pClone);
	MakeCurrent(pClone);
}

///////////////////////////////////////////////////////////////////////////////////
// Idle time handler

BOOL CMainFrame::Update()
{
	BOOL bMore = FALSE;
	
	if (m_Movie.IsPlaying()) {

		// Show the next movie frame
		m_Movie.Update();
		Status("Playing (%d)", m_Movie.GetFrame());
		return TRUE;
	}

	if (m_bPlayAnimation) {

		double l = m_Anim.GetLength();
		double t = m_Anim.GetCurTime();
		t += 0.1;
		if (t > l) {
			if (m_bLoopAnim) {
				m_Anim.SetTime(0.0);
			} else {
				m_bPlayAnimation = FALSE;
				Status("End of animation");
			}
		} else {
			m_Anim.SetTime(t);
		}
	}

	// See if the object controller wants to do anything
	if (m_pController) {
		m_pController->Update();
	}

	// Tell the 3D window to update
	if (m_wnd3d.Update(1)) {   // BUGBUG use delta better
		bMore = TRUE;
	}

	if (m_Movie.IsRecording()) {

		// Capture the current frame
		m_Movie.Update();
		Status("Recording (%d)", m_Movie.GetFrame());
		return TRUE;
	}

	return bMore;
}

/////////////////////////////////////////////////////////////////////////////////
// Frame recording

void CMainFrame::OnUpdateEditRecord(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_Movie.IsRecording());
}

void CMainFrame::OnEditRecord() 
{
	m_Movie.Record();
}

void CMainFrame::OnUpdateEditStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Movie.IsPlaying() || m_Movie.IsRecording());
}

void CMainFrame::OnEditStop() 
{
	m_Movie.Stop();	
}

void CMainFrame::OnUpdateEditPlay(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_Movie.IsPlaying() && (m_Movie.GetNumFrames() > 0));
}

void CMainFrame::OnEditPlay() 
{
	m_Movie.Play();
}

void CMainFrame::OnUpdateEditSaveAvi(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Movie.GetNumFrames() > 0);
}

void CMainFrame::OnEditSaveAvi() 
{
	if (!m_Movie.Save()) {
		AfxMessageBox("Failed to save AVI file");
	}
}

///////////////////////////////////////////////////////////////////////////////////
// Animation sequence recording

void CMainFrame::OnUpdateEditRecanim(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);	
}

void CMainFrame::OnEditRecanim() 
{
	// Start recording a new sequence
	m_bPlayAnimation = FALSE;
	m_Anim.DeleteAll();
	m_Anim.Attach(m_pCurShape);

	// Add the first key
	m_Anim.AddKey(0.0);

	Status("Ready to add animation key");
}

void CMainFrame::OnEditPlayanim() 
{
	m_bPlayAnimation = TRUE;
	m_bLoopAnim = FALSE;
	m_Anim.SetTime(0.0);
	Status("Playing animation");
}


void CMainFrame::OnEditPlayanimcont() 
{
	m_bPlayAnimation = TRUE;
	m_bLoopAnim = TRUE;
	m_Anim.SetTime(0.0);
	Status("Playing animation (loop)");
}

void CMainFrame::OnEditAddanimkey() 
{
	// Add a new key at the end
	m_Anim.AddKey(m_Anim.GetLength() + 1.0);
	Status("Added key %d", m_Anim.GetNumKeys());
}

void CMainFrame::OnUpdateEditAddanimkey(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Anim.GetNumKeys() > 0);
}

void CMainFrame::OnUpdateEditPlayanim(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Anim.GetNumKeys() > 0);
}

void CMainFrame::OnUpdateEditPlayanimcont(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Anim.GetNumKeys() > 0);
}

void CMainFrame::OnEditAnimdemo() 
{
	// Start a new scene
	NewScene();

	// Put in a planet
	OnEditInsworld();

	// Set up a new animation sequence
	m_Anim.DeleteAll();
	m_Anim.Attach(m_pCurShape); // (the planet)

	// Move the planet around and record the positions
	// as we go
	m_pCurShape->SetRotation(0, 1, 0, -0.3);
	double r = 5;
	for (double a = 0; a <=  6.3; a += 0.1) {

		// calculate the position
		C3dVector p(r * sin(a), 0, r + r * cos(a));

		// Put the shape there
		m_pCurShape->SetPosition(p);

		// Update the scene so it looks live
		Update();

		// record a key
		OnEditAddanimkey();
	}
	m_pCurShape->SetRotation(0, 1, 0, 0.0);

	// Now play back the animation
	OnEditPlayanimcont();
	
}

void CMainFrame::OnEditstopanim() 
{
	m_bPlayAnimation = FALSE;
	Status("Animation stopped");
}
