// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

class CTransformDlg;

class CMainFrame : public CFrameWnd
{
public:
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	C3dWnd		m_wnd3d;
	C3dScene* m_pScene;
	C3dController* m_pController;

// Operations
public:
	BOOL NewScene();
	BOOL OpenFile(const char* pszFile);
	void Status(const char* pszFormat, ...);
	BOOL Update();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	int m_iControlObj;
	int m_iControlType;
	int m_iObjCtrlDev;
	CRect m_rcWnd;
	BOOL m_bViewSelection;
	C3dShape* m_pSelBox;
	C3dShape* m_pCurShape;
	CMovie m_Movie;
	C3dAnimation m_Anim;
	BOOL m_bPlayAnimation;
	BOOL m_bLoopAnim;


	static C3dFrame* CALLBACK OnGetCtrlFrame(void* pArg);
	void SaveSettings();
	void RestoreSettings();
	void ShowSelection();
	void HideSelection();
	void MakeCurrent(C3dShape* pShape);
	static void CALLBACK OnSelChange(C3dShape* pShape, CPoint pt, void* pArg);

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg void OnMove(int x, int y);
	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
	afx_msg void OnEditInsertShape();
	afx_msg void OnViewRotate();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnUpdateEditControl(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewSelection(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditDeleteshape(CCmdUI* pCmdUI);
	afx_msg void OnEditDeleteshape();
	afx_msg void OnEditBkgndImg();
	afx_msg void OnEditInsworld();
	afx_msg void OnEditTree();
	afx_msg void OnUpdateEditClone(CCmdUI* pCmdUI);
	afx_msg void OnEditClone();
	afx_msg void OnEditInputdev();
	afx_msg void OnViewSelection();
	afx_msg void OnEditControl();
	afx_msg void OnEditRecord();
	afx_msg void OnUpdateEditStop(CCmdUI* pCmdUI);
	afx_msg void OnEditStop();
	afx_msg void OnUpdateEditPlay(CCmdUI* pCmdUI);
	afx_msg void OnEditPlay();
	afx_msg void OnUpdateEditRecord(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditSaveAvi(CCmdUI* pCmdUI);
	afx_msg void OnEditSaveAvi();
	afx_msg void OnEditRecanim();
	afx_msg void OnEditPlayanim();
	afx_msg void OnEditAddanimkey();
	afx_msg void OnUpdateEditRecanim(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditAddanimkey(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPlayanim(CCmdUI* pCmdUI);
	afx_msg void OnEditPlayanimcont();
	afx_msg void OnUpdateEditPlayanimcont(CCmdUI* pCmdUI);
	afx_msg void OnEditAnimdemo();
	afx_msg void OnEditstopanim();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
