// movie.h

class CMovieFrame
{
public:
	CMovieFrame(HBITMAP hBmp, BITMAPINFO* pBMI, void* pBits);
	virtual ~CMovieFrame();

public:
	HBITMAP m_hBmp;
	BITMAPINFO* m_pBMI;
	void* m_pBits;
};

class CMovieTake : public CPtrList
{
public:
	CMovieTake();
	virtual ~CMovieTake();
	void DeleteAll();
	CMovieFrame* RemoveHead() {return (CMovieFrame*) CPtrList::RemoveHead();}
	CMovieFrame* GetHead() {return (CMovieFrame*) CPtrList::GetHead();}
	CMovieFrame* GetAt(POSITION pos) {return (CMovieFrame*) CPtrList::GetAt(pos);}
	CMovieFrame* GetNext(POSITION& pos) {return (CMovieFrame*) CPtrList::GetNext(pos);}
	void SetPalette(CPalette* pPalette);
	CPalette* GetPalette() {return m_pPalette;}
	void SetSize(int w, int h) {m_iWidth = w; m_iHeight = h;}
	int GetWidth() {return m_iWidth;}
	int GetHeight() {return m_iHeight;}
	void Optimize();
	
protected:
	CPalette* m_pPalette;
	int m_iWidth;
	int m_iHeight;
};

class CMovie
{
public:
	CMovie();
	BOOL Create(C3dWnd* p3dWnd);
	BOOL Play();
	void Stop();
	BOOL Record();
	BOOL IsPlaying() {return m_bIsPlaying;}
	BOOL IsRecording() {return m_bIsRecording;}
	BOOL IsStopped() {return !m_bIsPlaying && !m_bIsRecording;}
	BOOL Update();
	int GetFrame() {return m_iCurFrame;}
	int GetNumFrames() {return m_Take.GetCount();}
	BOOL Save();

protected:
	C3dWnd* m_p3dWnd;
	BOOL m_bIsPlaying;
	BOOL m_bIsRecording;
	int m_iCurFrame;
	CMovieTake m_Take;
};